import java.net.*;
import java.io.*;

/**
 * Network Server - This is the Server side of the network.
 * 
 * @author David Couvrette
 * May 30th 2007
 * CSE190L
 * 
 */

public class NetworkServer implements Runnable {
  private Socket client;
  private PongModel model;
  private PrintStream out;
  private InputStream in;
  private ObjectOutputStream oos;
  
  /**
   * Initializes NetworkServer
   * Opens input and output streams
   * @param client The clients socket
   * @param model
   */
  public NetworkServer(Socket client, PongModel model) {
    this.client = client;
    this.model = model;
    model.setClient(this);
    try {
      in = client.getInputStream();
      out = new PrintStream(client.getOutputStream());
    } catch (IOException e) {
      e.printStackTrace();
    }
  }
  
  /**
   * Listen for incoming message from server
   */
  public void run() {
    try {
      InputStream in = client.getInputStream();
      while (true) {
        ObjectInputStream ois = new ObjectInputStream(in);
        Paddle rightPaddle = (Paddle)ois.readObject();
        model.updatePaddle(rightPaddle);
      }
    } catch (Exception e) {
      System.out.println("Updating right paddle from client: " + e);
    }
  }
  
  /**
   * Sends a message to the client containing the model
   */
  public void sendModel() {
    try {
      ObjectOutputStream oos = new ObjectOutputStream(client.getOutputStream());
      oos.writeObject(model);
      oos.flush();
    } catch (Exception e) {
      System.out.println("Trying to send model: " + e);
    }
  }
}