import java.awt.*;

/**
 * PaddleAI - An AI for the paddle that tries to keep its paddle 
 * at the same y position as the ball.  This class is not really
 * used anymore since it is a 2-player game.
 * 
 * @author David Couvrette
 * May 30th 2007
 * CSE190L
 * 
 */

public class PaddleAI {
  
  // speed the paddle can move at
  public static final double PADDLESPEED = 1.9;
  
  private PongModel model;
  
  /**
   * @param model A reference to the model
   */
  public PaddleAI(PongModel model) {
    this.model = model;
  }
  
  /**
   * Calculates where the ball is in relation to the paddle.
   * It then moves the paddle so that it will be closer to
   * the ball's y coordinate.
   */
  public void updatePaddles() {
    Paddle leftPaddle = model.getLeftPaddle();
    Paddle rightPaddle = model.getRightPaddle();
    Point ball = model.getBall();
    if (rightPaddle.getY() > ball.getY()) {
      rightPaddle.setY(rightPaddle.getY() - PADDLESPEED);
    } else {
      rightPaddle.setY(rightPaddle.getY() + PADDLESPEED);
    }
  }
}