import java.net.*;
import java.io.*;

/**
 * Wait For Connection - Server waits for the clients to connect
 * 
 * @author David Couvrette
 * May 30th 2007
 * CSE190L
 * 
 */

public class PongWaitForConnect implements Runnable {
  private PongModel model;
  
  /**
   * @param model
   */
  public PongWaitForConnect (PongModel model) {
    this.model = model;
  }
  
  /**
   * Waits for a client to connect on port 500
   */
  public void run() {
    try {
      ServerSocket sSocket = new ServerSocket(500);
      // wait for incoming client connection
     
        Socket client = sSocket.accept();
        Thread t = new Thread(new NetworkServer(client, model));
        t.start();
    
    } catch(IOException e) {
      e.printStackTrace();
    }
  }
}